#ifndef Map_H
#define Map_H

#include <Bild.h>
#include <Random.h>
#include <Datei.h>
#include "KSGNetwork.h"

using namespace Framework;

class Map : public virtual ReferenceCounter
{
private:
    RCArray< Array< int > > *map;
    int score;
    int scoreCheck;
    int breite;
    int hhe;
    int geschwindigkeit;
    int bAnzahl;
    double next;
    bool beendet;
    bool rend;
    double gameTime;
    Datei capture;
    Critical cs;
    KSGClient::MinigameServerClient *klient;
    RandomGenerator *rGen;
    // private
    void remove( int x, int y );

public:
    // Konstruktor
    Map( KSGClient::MinigameServerClient *klient );
    // Destruktor
    ~Map();
    // nicht constant
    void reset( Text *zOptionen );
    void doPublicMausEreignis( MausEreignis &me );
    void doTastaturEreignis( TastaturEreignis &te );
    bool tick( double tickVal );
    void render( Bild &zRObj );
    void speichern();
    // constant
    int getScore() const;
    bool istBeendet() const;
};

#endif